; Vector Table Mapped to Address 0 at Reset
; Linker requires __Vectors to be exported
 
          AREA    RESET, DATA, READONLY
          EXPORT  __Vectors
 
__Vectors 
			DCD  0x20001000     ; stack pointer value when stack is empty
			DCD  Reset_Handler  ; reset vector
STRING1 	DCB "the andthe the manthe the the said they must go" ;String1
EoS 		DCB  0x00 ;end of string1
SUBSTRING	DCB	"the "

			
			ALIGN
; data area that can be modified (readwrite)
			AREA Data, DATA, READWRITE
STRING2 	space 0xFF ;just allocating 255 bytes 
			ALIGN
; The program
; Linker requires Reset_Handler
 
          AREA    MYCODE, CODE, READONLY
 
		ENTRY
		EXPORT Reset_Handler
  
Reset_Handler
;;;;;;;;;;User Code Starts from the next line;;;;;;;;;;;;
;; code to copy data from ROM to RAM on startup i.e. from readonly to readwrite area in memory
		
; any other startup code here
			B		mainprog

mainprog	;;add your code here 
			LDR			r0,=STRING1				; initialize string pointer registers
			LDR			r1,=SUBSTRING
			LDR			r1,[r1]					; load key word for search string 
			LDR			r8,=STRING2				; initialize pointer to result string
			MOV			r7,#0x1					; used as flag to indicate previous char was a space
												; initialized to 1 for first word match
nextchar
			LDR			r2,[r0]					;load 4 characters from source string
			CMP			r2,r1					; compare with key word	
			BEQ			foundsubstring			; branch to check white space character as prefix
			; here if not matching
			; copy one char in STRING2
copychar
			LDRB		r2,[r0],#1				; copy character
			STRB		r2,[r8],#1				; store in result string
			CMP			r2,#" "					; check if character is space
			MOVEQ		r7,#0x1					; set flag if so
			MOVNE		r7,#0x0					; clear flag if not
			CMP			r2,#0x0					; check end of string
			BNE			nextchar				; otherwise loop till end of string
			B			.						; end of program
foundsubstring
			; check if initial character was a space
			; using $r7 as flag
			CMP			r7,#0x1					; check if previous character was space
			ADDEQ		r0,r0,#0x3				;skip 3 characters if previous character was a space
			BNE			copychar				; else copy character it is part of another word
			B			nextchar				; branch to copy subroutine
			
			END